$.fn.isInTheViewport = function () {
    var deviation = -$(window).height() * 0.5;
    if (deviation < 0 && (-deviation > (document.documentElement.clientHeight / 2))) {
        deviation = document.documentElement.clientHeight / 2;
    }
    var elementHeight = $(this)[0].offsetHeight;
    var bounding = $(this)[0].getBoundingClientRect();
    return bounding.top + deviation >= -elementHeight && bounding.bottom - deviation <= (window.innerHeight || document.documentElement.clientHeight) + elementHeight;
}

class stickyScroll {
    setWrapHeight = () => {
        $(".ss-wrap").each(function () {
            let $this = $(this); // .ss-wrap
            $this.height($this.find(".ss-content").children('[class^="section-"]').length * $this.find(".ss-content").height());
            if ($this.find(".hidden-grid").length <= 0) {
                $this.append('<div class="hidden-grid"></div>');
                if ($this.find(".ss-navigator").length <= 0) {
                    $this.find('.ss-content').append('<div class="ss-navigator"></div>');
                }
                for (let $i = 1; $i <= $this.find(".ss-content").children('[class^="section-"]').length; $i++) {
                    $('<span data-position="' + $i + '"></span>').appendTo($this.find(".hidden-grid"));
                    let $index = $i;
                    if ($i < 10) {
                        $index = "0" + $i;
                    }
                    $this.find(".ss-navigator").append('<div class="index" data-index="' + $i + '">' + $index + '</div>');
                }
                $this.find(".hidden-grid span").height($this.find(".ss-content").height());
            } else {
                $this.find(".hidden-grid span").height($this.find(".ss-content").height());
            }
            if ($(window).scrollTop() > $this.offset().top + $this.height()) {
                $this.find('.ss-content').attr("data-current-section", $this.find(".ss-content").children('[class^="section-"]').length);
            }
            let order = $this.find('.ss-content').data("current-section");
            $this.find('.ss-navigator').find('[data-index="' + order + '"]').addClass("active").siblings(".index").removeClass("active");

        });
    }
    fixSSContent = () => {
        $(".ss-wrap").each(function () {
            let $this = $(this); // .ss-wrap
            if (($(window).scrollTop() > $this.offset().top) && $(window).scrollTop() < ($this.offset().top + $this.height() - $this.find(".ss-content").height())) {
                if (!$this.find('.ss-content').hasClass("fixed")) {
                    $this.find('.ss-content').addClass("fixed");
                }
                if ($this.find('.ss-content').hasClass("bottom")) {
                    $this.find('.ss-content').removeClass("bottom");
                }
            } else if ($(window).scrollTop() >= ($this.offset().top + $this.height() - $this.find(".ss-content").height())) {
                if (!$this.find('.ss-content').hasClass("bottom")) {
                    $this.find('.ss-content').addClass("bottom fixed");
                }
            } else {
                if ($this.find('.ss-content').hasClass("fixed")) {
                    $this.find('.ss-content').removeClass("fixed bottom");
                }
            }
        });
    }
    setCurrentSection = () => {
        $(".ss-wrap").each(function () {
            let $this = $(this); // .ss-wrap
            $this.find(".hidden-grid span").each(function () {
                if ($(this).isInTheViewport()) {
                    let order = $(this).data("position");
                    if ($this.find('.ss-content').attr("data-current-section") != order) {
                        $this.find('.ss-content').attr("data-current-section", order);
                        $this.find('.ss-navigator').find('[data-index="' + order + '"]').addClass("active").siblings(".index").removeClass("active");
                    }
                }
            });
        });
    }

    clickNavigator = () => {
        $('.ss-navigator div').on("click", function () {
            let order = $(this).data("index");
            $(this).parents(".ss-wrap").find(".ss-content").attr("data-current-section", order);
            $(this).addClass("active").siblings().removeClass("active");
            let offset = $(this).parents(".ss-wrap").find('.hidden-grid').find('[data-position="' + order + '"]').offset().top;
            $("html,body")[0].scrollTo(0, offset);
        });
    }
}

const ss = new stickyScroll();
$(function () {
    ss.setWrapHeight();
    ss.fixSSContent();
    ss.setCurrentSection();
    ss.clickNavigator();
});

let resizeTimer;
$(window).on("resize", () => {
    clearTimeout(resizeTimer);
    resizeTimer = setTimeout(() => {
        ss.setWrapHeight();
        ss.fixSSContent();
        ss.setCurrentSection();
    }, 200);
});

$(window).on("scroll", () => {
    ss.fixSSContent();
    ss.setCurrentSection();
});